package com.crov.controllers;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.bind.annotation.RestController;

import com.crov.services.UsuarioModelService;

@RestController
@CrossOrigin(origins = "http://localhost:5173")
@RequestMapping("/api/usuariosModel")
public class UsuarioModelController {

	@Autowired
	UsuarioModelService usuarioService;
	//@Autowired
	//CorteService corteService;
	
	PostMapping(value = "/getUsersByEmpresaUserModel", produces = MediaType.APPLICATION_JSON_VALUE)
	@ResponseStatus(code = HttpStatus.OK)
	public List<UsuarioModel> getUsersByEmpresaUserModel(@RequestBody EmpresaUserModel empresaUserModel) {
		return usuarioService.getListUsuarioModelByEmpresaUserModel(empresaUserModel);
	}
	
	@PostMapping(value = "/save", produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	@ResponseStatus(code = HttpStatus.OK)
	public boolean saveUser(@RequestBody UsuarioModel usuarioModel) {
		 usuarioService.saveUser(usuarioModel);
		 UsuarioModel usuarioModelNuevo = usuarioService.getUsuarioModelByEmpresaUserModelAndIdPuntoVenta(usuarioModel.getEmpresaUserModel(), usuarioModel.getIdPuntoVenta());
		 Utilerias util = new Utilerias();
		 CorteModel corteModel = new CorteModel();
		 corteModel.setComentarios("Corte del nuevo usuario");
		 corteModel.setEmpresaUserModel(usuarioModel.getEmpresaUserModel());
		 corteModel.setEstatus(1);
		 corteModel.setFecha(util.sumarDiasAFecha(new Date(), -30));
		 corteModel.setId(UUID.randomUUID());
		 corteModel.setIdPuntoVenta(1);
		 corteModel.setMontoEsperado(0d);
		 corteModel.setMontoReportado(0d);
		 corteModel.setUsuarioEntrega(usuarioModelNuevo);
		 corteModel.setUsuarioRecibe(usuarioModelNuevo);
		 corteModel.setPrecorte(0);
		 return corteService.save(corteModel);
	}
	
	@PostMapping (value ="/sincronizacia-pv",produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE )
	@ResponseStatus(code =HttpStatus.OK)
	public Map<Integer, String> sincronizarUsuario(@RequestBody List<UsuarioModel> listUsuarioModel) {
		Map<Integer, String> map = new HashMap<>();
		for(int i=0; i<=listUsuarioModel.size()-1;i++) {
			try {
			boolean owo = usuarioService.saveUser(listUsuarioModel.get(i));
			if(owo) {
				map.put(listUsuarioModel.get(i).getIdPuntoVenta(), "Si");
			}else {
				map.put(listUsuarioModel.get(i).getIdPuntoVenta(), "No");
			}
			}catch(Exception e) {
				
			}
			
		}
		return map;
	}
	
	@PostMapping(value="status", produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	@ResponseStatus(code = HttpStatus.OK)
	public boolean status(@RequestBody GenericSearchDTO genericSearchDTO) {
		UsuarioModel usuarioModel = usuarioService.getUsuarioModelByEmpresaUserModelAndIdPuntoVenta(genericSearchDTO.getEmpresaUserModel(), genericSearchDTO.getIdExtra());
		usuarioModel.setActivo(genericSearchDTO.getIdExtraa());
		return usuarioService.saveUser(usuarioModel);
	}
}
