package com.crov.crovWSTotal.config;

import java.util.Collections;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.ApiInfo;
import springfox.documentation.service.Contact;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

@Configuration
@EnableSwagger2
public class SwaggerConfig implements WebMvcConfigurer{

    @Bean
    public Docket api() {
        return new Docket(DocumentationType.SWAGGER_2)
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.crov.controllers"))
                .paths(PathSelectors.any())
                .build()
                .pathMapping("/")
                .apiInfo(getApiInfo())
				;
    }
    
    private ApiInfo getApiInfo() {
		return new ApiInfo(
				"CROV Services",
				"Order Service API Description",
				"1.0",
				"https://crov.mx",
				new Contact("Soporte", "https://www.crov.mx/contacto", "ventas@crov.mx"),
				"CROV Internal",
				"https://www.crov.mx",
				Collections.emptyList()
				);
	}
}
