package com.crov.models;

import java.util.UUID;

import org.springframework.lang.NonNull;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.EnumType;
import jakarta.persistence.Enumerated;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.Id;
import jakarta.persistence.PrePersist;
import jakarta.persistence.Table;


@Entity
@Table (name ="ACTIVATION_KEY")
public class ActivationKey {
	
	@Id
    @Column(name = "id", updatable = false, nullable = false, columnDefinition = "VARCHAR(255)")
    private String id;
	@PrePersist
    public void prePersist() {
        if (id == null || id.isEmpty()) {
            id = UUID.randomUUID().toString();
        }
    }
	@NonNull
	@Column(name = "activation_code", updatable = false, nullable = false, columnDefinition = "VARCHAR(255)")
	private String activation_code;
	@NonNull
	@Enumerated(value = EnumType.STRING)
	private TipoKey tipo_key;
	@NonNull
	@Enumerated(value = EnumType.STRING)
	private ActiveKey active_key;
	
	private String modules;
	
	private Integer activationTime;
	
	public enum TipoKey{
		Lifetime,
		Proof,
		Rent,
		ProductosAbarrotes,
		ProductosFarmacia
	}
	
	public enum ActiveKey{
		Yes,
		No
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getActivation_code() {
		return activation_code;
	}

	public void setActivation_code(String activation_code) {
		this.activation_code = activation_code;
	}

	public TipoKey getTipo_key() {
		return tipo_key;
	}

	public void setTipo_key(TipoKey tipo_key) {
		this.tipo_key = tipo_key;
	}

	public ActiveKey getActive_key() {
		return active_key;
	}

	public void setActive_key(ActiveKey active_key) {
		this.active_key = active_key;
	}
	

	public String getModules() {
		return modules;
	}

	public void setModules(String modules) {
		this.modules = modules;
	}
	
	

	public Integer getActivationTime() {
		return activationTime;
	}

	public void setActivationTime(Integer activationTime) {
		this.activationTime = activationTime;
	}

	public ActivationKey(String id) {
		this.id = id;
	}
	public ActivationKey () {
		
	}
	
	
	
}
