package com.crov.models;

import java.util.UUID;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;
import jakarta.persistence.EnumType;
import jakarta.persistence.Enumerated;

@Entity
@Table (name ="EMPRESA_USER")
public class EmpresaUser {

	@Id
    @GeneratedValue
    @Column(name = "id", updatable = false, nullable = false, columnDefinition = "VARCHAR(255)")
    private UUID id;
	
	@Column(name="id_software_model")
	private String softwareModel;
	
	@Column(name ="user_name")
	private String userName;
	
	@Column(name="password")
	private String password;
	
	@Enumerated(EnumType.STRING)
	@Column(name ="active")
	private Active active;
	
	@ManyToOne
	@JoinColumn(name = "id_empresa")
	private Empresa empresaModel;
	
	@Enumerated(EnumType.STRING)
	@Column(name ="tipo_cliente")
	private TipoCliente tipoCliente;
	
	@Column(name="no_backups")
	private Integer noBackups;
	
	public enum Active{
		ENABLED, DISABLED
	}
	
	public enum TipoCliente{
		MOVIL, RESPALDO, AMBOS, NADA
	}
	

	public UUID getId() {
		return id;
	}
	public void setId(UUID id) {
		this.id = id;
	}
	
	public String getSoftwareModel() {
		return softwareModel;
	}

	public void setSoftwareModel(String softwareModel) {
		this.softwareModel = softwareModel;
	}

	public String getUserName() {
		return userName;
	}
	public void setUserName(String userName) {
		this.userName = userName;
	}
	public String getPassword() {
		return password;
	}
	public void setPassword(String password) {
		this.password = password;
	}
	public Active getActive() {
		return active;
	}
	public void setActive(Active active) {
		this.active = active;
	}
	public Empresa getEmpresaModel() {
		return empresaModel;
	}
	public void setEmpresaModel(Empresa empresaModel) {
		this.empresaModel = empresaModel;
	}
	public TipoCliente getTipoCliente() {
		return tipoCliente==null?TipoCliente.NADA:tipoCliente;
	}
	public void setTipoCliente(TipoCliente tipoCliente) {
		this.tipoCliente = tipoCliente;
	}
	public Integer getNoBackups() {
		return noBackups;
	}
	public void setNoBackups(Integer noBackups) {
		this.noBackups = noBackups;
	}
	
}
