package com.crov.models;

import java.util.Date;
import java.util.UUID;

import org.springframework.lang.NonNull;

import com.fasterxml.jackson.annotation.JsonFormat;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.EnumType;
import jakarta.persistence.Enumerated;
import jakarta.persistence.Id;
import jakarta.persistence.PrePersist;
import jakarta.persistence.Table;

@Entity
@Table (name ="PERSON_SOFTWARE")
public class PersonSoftware {
	
	@Id
    @Column(name = "id", updatable = false, nullable = false, columnDefinition = "VARCHAR(255)")
    private String id;
	
	@PrePersist
    public void prePersist() {
        if (id == null || id.isEmpty()) {
            id = UUID.randomUUID().toString();
        }
    }
	@NonNull 
	private String first_name;
	
	private String second_name;
	
	private String last_name;
	
	private String middle_name;
	
	private String mail;
	
	
	private Date birthdate;
	
	private String curp;
	
	private String rfc;
	
	private String phone;
	
	@Column(name="active", nullable = false, length = 8 )
    @Enumerated(value = EnumType.STRING)
    private ActivePerson active;
	
	@Column(name="black_list", nullable = false, length = 8 )
	@Enumerated(value = EnumType.STRING)
	private BlackListPerson black_list;
	
	private String black_list_description;
	
	@JsonFormat(pattern="yyyy-MM-dd")
	private Date created_on;
	
	public PersonSoftware(String id, String first_name, String second_name, String last_name, String middle_name,
			String mail, Date birthdate, String curp, String rfc, String phone, ActivePerson active, BlackListPerson black_list,
			String black_list_description, Date created_on) {
		this.id = id;
		this.first_name = first_name;
		this.second_name = second_name;
		this.last_name = last_name;
		this.middle_name = middle_name;
		this.mail = mail;
		this.birthdate = birthdate;
		this.curp = curp;
		this.rfc = rfc;
		this.phone = phone;
		this.active = active;
		this.black_list = black_list;
		this.black_list_description = black_list_description;
		this.created_on = created_on;
	}
	public PersonSoftware() {
		
	}
	public PersonSoftware(String id) {
		this.id = id;
	}
	public enum ActivePerson{
	Active,
	Inactive
	}
	public enum BlackListPerson{
		Enabled,
		Disabled
	}
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getFirst_name() {
		return first_name;
	}
	public void setFirst_name(String first_name) {
		this.first_name = first_name;
	}
	public String getSecond_name() {
		return second_name;
	}
	public void setSecond_name(String second_name) {
		this.second_name = second_name;
	}
	public String getLast_name() {
		return last_name;
	}
	public void setLast_name(String last_name) {
		this.last_name = last_name;
	}
	public String getMiddle_name() {
		return middle_name;
	}
	public void setMiddle_name(String middle_name) {
		this.middle_name = middle_name;
	}
	public String getMail() {
		return mail;
	}
	public void setMail(String mail) {
		this.mail = mail;
	}
	public Date getBirthdate() {
		return birthdate;
	}
	public void setBirthdate(Date birthdate) {
		this.birthdate = birthdate;
	}
	public String getCurp() {
		return curp;
	}
	public void setCurp(String curp) {
		this.curp = curp;
	}
	public String getRfc() {
		return rfc;
	}
	public void setRfc(String rfc) {
		this.rfc = rfc;
	}
	public String getPhone() {
		return phone;
	}
	public void setPhone(String phone) {
		this.phone = phone;
	}
	public ActivePerson getActivePerson() {
		return active;
	}
	public void setActivePerson(ActivePerson active) {
		this.active = active;
	}
	public BlackListPerson getBlack_listPerson() {
		return black_list;
	}
	public void setBlack_listPerson(BlackListPerson black_list) {
		this.black_list = black_list;
	}
	public String getBlack_list_description() {
		return black_list_description;
	}
	public void setBlack_list_description(String black_list_description) {
		this.black_list_description = black_list_description;
	}
	public Date getCreated_on() {
		return created_on;
	}
	public void setCreated_on(Date created_on) {
		this.created_on = created_on;
	}
	
	
}
