package com.crov.models;

import java.util.Date;
import java.util.UUID;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.PrePersist;
import jakarta.persistence.Table;
import jakarta.persistence.Temporal;
import jakarta.persistence.TemporalType;


@Entity
@Table(name = "USUARIO")
public class UsuarioModel {

	@Id
    @Column(name = "id", updatable = false, nullable = false, columnDefinition = "VARCHAR(255)")
	private String id;
	@PrePersist
    public void prePersist() {
        if (id == null || id.isEmpty()) {
            id = UUID.randomUUID().toString();
        }
    }
	@Column(name="id_punto_venta")
	private Integer idPuntoVenta;
	@Column(name ="login")
	private String login;
	@Column(name="nombre")
	private String nombre;
	@Column(name="apellidos")
	private String apellidos;
	@Column(name="calular")
	private String celular;
	@Column(name="email")
	private String email;
	@Column(name="tipoCargo")
	private String tipoCargo;
	@Column(name="descripcion")
	private String descipcion;
	@Column(name="activo")
	private Integer activo;
	@Temporal(TemporalType.TIMESTAMP)
    @Column(name = "fec_registro", length = 19)
    private Date fec_registro;
	@ManyToOne
	@JoinColumn(name = "id_empresa")
	private EmpresaUser empresaUserModel;
	
	public UsuarioModel() {
	}
	public UsuarioModel(String id, Integer idPuntoVenta, String login, String nombre, String apellidos, String celular,
			String email, String tipoCargo, String descipcion, Integer activo, Date fec_registro,
			EmpresaUser empresaModel) {
		super();
		this.id = id;
		this.idPuntoVenta = idPuntoVenta;
		this.login = login;
		this.nombre = nombre;
		this.apellidos = apellidos;
		this.celular = celular;
		this.email = email;
		this.tipoCargo = tipoCargo;
		this.descipcion = descipcion;
		this.activo = activo;
		this.fec_registro = fec_registro;
		this.empresaUserModel = empresaModel;
	}
	public UsuarioModel(String id, Integer idPuntoVenta) {
		super();
		this.id = id;
		this.idPuntoVenta = idPuntoVenta;
	}
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public Integer getIdPuntoVenta() {
		return idPuntoVenta;
	}
	public void setIdPuntoVenta(Integer idPuntoVenta) {
		this.idPuntoVenta = idPuntoVenta;
	}
	public String getLogin() {
		return login;
	}
	public void setLogin(String login) {
		this.login = login;
	}
	public String getNombre() {
		return nombre;
	}
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}
	public String getApellidos() {
		return apellidos;
	}
	public void setApellidos(String apellidos) {
		this.apellidos = apellidos;
	}
	public String getCelular() {
		return celular;
	}
	public void setCelular(String celular) {
		this.celular = celular;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public String getTipoCargo() {
		return tipoCargo;
	}
	public void setTipoCargo(String tipoCargo) {
		this.tipoCargo = tipoCargo;
	}
	public String getDescipcion() {
		return descipcion;
	}
	public void setDescipcion(String descipcion) {
		this.descipcion = descipcion;
	}
	public Integer getActivo() {
		return activo;
	}
	public void setActivo(Integer activo) {
		this.activo = activo;
	}
	public Date getFec_registro() {
		return fec_registro;
	}
	public void setFec_registro(Date fec_registro) {
		this.fec_registro = fec_registro;
	}
	public EmpresaUser getEmpresaUserModel() {
		return empresaUserModel;
	}
	public void setEmpresaUserModel(EmpresaUser empresaUserModel) {
		this.empresaUserModel = empresaUserModel;
	}
	
}
