package com.crov.repositories;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.crov.models.ActivationKey;

@Repository
public interface  ActivationKeyRepository extends JpaRepository<ActivationKey, String>{

	@Query(value="SELECT IF(EXISTS(SELECT ac.activation_code, ac.active_key "
			+ "FROM activation_key ac WHERE ac.activation_code =:actCode AND active_key = 'Yes'),1,0)AS resul", nativeQuery=true)
	int revisarLicenciaActivaSinUso(@Param ("actCode")String activation_code );
	
	@Query(value="SELECT IF(EXISTS(SELECT ac.activation_code, ac.active_key "
			+ "FROM activation_key ac WHERE ac.activation_code =:actCode AND active_key = 'Yes' "
			+ "AND tipo_key ='Lifetime'),1,0)AS resul", nativeQuery=true)
	int checkActiveCodeAndVitalicieKey(@Param ("actCode")String activation_code );
	
	@Transactional
    @Modifying
	@Query(value="UPDATE activation_key ac SET ac.active_key = 'No' WHERE ac.id =:id_key" ,nativeQuery=true)
	void updateActKeyToNo(@Param ("id_key") String id_key);
	
	@Query(value="SELECT ac.* FROM activation_key ac WHERE ac.activation_code =:acti_cod" ,nativeQuery=true)
	ActivationKey getActivationCodePorCodigoActivacion(@Param ("acti_cod") String activation_code);
}
