package com.crov.repositories;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.crov.models.Software;

@Repository
public interface SoftwareRepository extends JpaRepository<Software, String>{

	@Query(value="SELECT IF(EXISTS(SELECT cl.mac FROM customer_license_by_product cl  WHERE cl.mac =:vaMac ),1,0 )", nativeQuery=true)
	int revisarMacExistePreviamente(@Param ("vaMac")String valueMac );
	
	@Query(value="SELECT cl.* FROM customer_license_by_product cl WHERE cl.mac =:data_mac" ,nativeQuery=true)
	Software getSoftwareByMac(@Param ("data_mac") String mac);
	
	@Query(value="SELECT cl.id FROM customer_license_by_product cl WHERE cl.token_product =:token" ,nativeQuery=true)
	String getSoftwareByToken(@Param ("token") String mac);
}
