package com.crov.repositories;

import java.util.List;
import java.util.Optional;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import com.crov.models.EmpresaUser;
import com.crov.models.UsuarioModel;

@Repository
public interface UsuarioModelRepository extends JpaRepository<UsuarioModel, String>{

	List<UsuarioModel> findByEmpresaUserModel(EmpresaUser empresaUserModel);
	
	List<UsuarioModel> findByEmpresaUserModelAndActivo(EmpresaUser empresaUserModel, Integer activo);
	
	UsuarioModel findByEmpresaUserModelAndIdPuntoVenta(EmpresaUser empresaModel, Integer idPuntoVenta);
	
	Optional<UsuarioModel> findById(String uuid);
}
