package com.crov.repositories;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;
import java.util.Optional;

import com.crov.models.Usuario;

@Repository
public interface UsuarioRepository extends JpaRepository<Usuario, Long>{

	List<Usuario> findByActivoTrue(); // Obtiene solo los Usuario con 'activo = true'
	
	@Query("SELECT u FROM Usuario u WHERE u.correo = :correo AND u.password = :password AND u.activo = true")
    Optional<Usuario> findByCorreoAndPasswordAndActivo(
            @Param("correo") String correo, 
            @Param("password") String password
    );
}
