package com.crov.services;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.crov.models.Distribuidor;
import com.crov.repositories.DistribuidorRepository;
import com.crov.requests.DistribuidorEditarRequest;
import com.crov.requests.DistribuidorGuadarRequest;

@Service
public class DistribuidorService {

	@Autowired
    private DistribuidorRepository distribuidorRepository;
	
	public Distribuidor guardarDistribuidor(DistribuidorGuadarRequest distribuidorRequest) {
		
		Distribuidor distribuidor = new Distribuidor();
		
		distribuidor.setPrimerNombre(distribuidorRequest.getPrimerNombre());
		distribuidor.setSegundoNombre(distribuidorRequest.getSegundoNombre());
		distribuidor.setApellidoPaterno(distribuidorRequest.getApellidoPaterno());
		distribuidor.setApellidoMaterno(distribuidorRequest.getApellidoMaterno());
		distribuidor.setTelefono(distribuidorRequest.getTelefono());
		distribuidor.setCorreo(distribuidorRequest.getCorreo());
		distribuidor.setDireccion(distribuidorRequest.getDireccion());
		distribuidor.setCiudad(distribuidorRequest.getCiudad());
		distribuidor.setNivel(distribuidorRequest.getNivel());
		distribuidor.setActivo(true);
        distribuidor.setFechaCreacion(new Date()); 
        return distribuidorRepository.save(distribuidor);
    }
	
	public List<Distribuidor> obtenerDistribuidoresActivos() {
        return distribuidorRepository.findByActivoTrue();
    }
	
	public Distribuidor eliminar(Long id) {
        Distribuidor distribuidor = distribuidorRepository.findById(id)
                .orElseThrow(() -> new RuntimeException("Distribuidor no encontrado con ID: " + id));
        distribuidor.setActivo(false);
        return distribuidorRepository.save(distribuidor);
    }
	
	public Distribuidor obtenerDistribuidor(Long id) {
        Distribuidor distribuidor = distribuidorRepository.findById(id)
                .orElseThrow(() -> new RuntimeException("Distribuidor no encontrado con ID: " + id));
        return distribuidor;
    }
	
	public Distribuidor editarDistribuidor(DistribuidorEditarRequest distribuidorRequest) {
		
		Distribuidor distribuidor = distribuidorRepository.findById(distribuidorRequest.getId())
				.orElseThrow(() -> new RuntimeException("Distribuidor no encontrado con ID: " + distribuidorRequest.getId()));
		
		distribuidor.setPrimerNombre(distribuidorRequest.getPrimerNombre());
		distribuidor.setSegundoNombre(distribuidorRequest.getSegundoNombre());
		distribuidor.setApellidoPaterno(distribuidorRequest.getApellidoPaterno());
		distribuidor.setApellidoMaterno(distribuidorRequest.getApellidoMaterno());
		distribuidor.setTelefono(distribuidorRequest.getTelefono());
		distribuidor.setCorreo(distribuidorRequest.getCorreo());
		distribuidor.setDireccion(distribuidorRequest.getDireccion());
		distribuidor.setCiudad(distribuidorRequest.getCiudad());
		distribuidor.setNivel(distribuidorRequest.getNivel());
		distribuidor.setActivo(distribuidorRequest.isActivo());
		
        return distribuidorRepository.save(distribuidor);
    }
}
