package com.crov.services;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.crov.models.EmpresaUser;
import com.crov.models.UsuarioModel;
import com.crov.repositories.UsuarioModelRepository;

@Service
public class UsuarioModelService {

	@Autowired
	UsuarioModelRepository usuarioRepository;
	
	public List<UsuarioModel> getListUsuarioModelByEmpresaUserModel(EmpresaUser empresaUserModel){
		return usuarioRepository.findByEmpresaUserModelAndActivo(empresaUserModel,1);
	}
	
	public UsuarioModel getUsuarioModelByEmpresaUserModelAndIdPuntoVenta(EmpresaUser empresaModel, Integer idPuntoVenta) {
		return usuarioRepository.findByEmpresaUserModelAndIdPuntoVenta(empresaModel, idPuntoVenta);
	}
	
	
	public Optional<UsuarioModel> findById(String id){
		return usuarioRepository.findById(id);
		
	}
	
	public boolean saveUser(UsuarioModel usuarioModel) {
		return usuarioRepository.save(usuarioModel) != null;
	}
}
